#!/bin/sh

### BEGIN INIT INFO
# Provides:          startQueueCreationUtil.sh
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6 
# Short-Description: Start daemon at boot time
# Description:       Automatic queue creation while USB plugged in with Printers.
### END INIT INFO

trap 'clean_up; exit 1' 1 2 15 2>/dev/null

clean_up()
{
	#echo "SIGHUP/SIGCHLD/SIGTERM/SIGINT signal received"
	val=`ps -aef | grep -w "QueueCreationUtility" | grep -v "grep"`
	if [ $? -eq 0 ]; then
		for a in `ps -aef | grep -w "QueueCreationUtility" | grep -v "grep" | tr ' ' '@'`
		do
			pid=`echo $a | tr '@' ' ' | awk -F" " '{print $2}'`
			kill -14 $pid
		done
	fi
}


case "$1" in
	start)
		clean_up
		while [ 1 ]
		do
			if [ -f /usr/local/Printer/ppd/QueueCreationUtility ]; then
				if [ -f /etc/SuSE-release ]; then
					ret=`/usr/local/Printer/ppd/QueueCreationUtility "Pantum" "1"`
				else
					ret=`/usr/local/Printer/ppd/QueueCreationUtility "Pantum" "0"`
				fi
			elif [ -f /usr/local/PPD/ppd/QueueCreationUtility ]; then
				if [ -f /etc/SuSE-release ]; then
					ret=`/usr/local/PPD/ppd/QueueCreationUtility "Pantum" "1"`
				else
					ret=`/usr/local/PPD/ppd/QueueCreationUtility "Pantum" "0"`
				fi
			fi
			if [ $? -ne 14 ]; then
				continue
			else
				break
			fi
		done
		;;
	stop)
		clean_up
		;;
	restart)
		clean_up
		while [ 1 ]
		do
			if [ -f /usr/local/Printer/ppd/QueueCreationUtility ]; then
				if [ -f /etc/SuSE-release ]; then
					ret=`/usr/local/Printer/ppd/QueueCreationUtility "Pantum" "1"`
				else
					ret=`/usr/local/Printer/ppd/QueueCreationUtility "Pantum" "0"`
				fi
			elif [ -f /usr/local/PPD/ppd/QueueCreationUtility ]; then
				if [ -f /etc/SuSE-release ]; then
					ret=`/usr/local/PPD/ppd/QueueCreationUtility "Pantum" "1"`
				else
					ret=`/usr/local/PPD/ppd/QueueCreationUtility "Pantum" "0"`
				fi
			fi
			if [ $? -ne 14 ]; then
				continue
			else
				break
			fi
		done
		;;
	status)
		val1=`ps -aef | grep -w "startQueueCreationUtil.sh" | grep -v "grep" >/dev/null 2>&1`
		if [ $? -eq 0 ]; then
			val=`ps -aef | grep -w "QueueCreationUtility" | grep -v "grep" >/dev/null 2>&1`
			if [ $? -eq 0 ]; then
				echo "Process is running..."
			else
				echo "Process is not running properly, need to restart"
			fi
		else
			echo "Process is not running..."
		fi
		;;
	*)
		echo "Usage: $0 {start|stop|status|restart}"
esac

exit 0
